import java.io.*;
import javax.swing.*;
import javax.swing.text.*;
import java.awt.*;
import javax.swing.text.html.*;

// Muestra como se puede leer un fichero con formato
// Unicode y mostrar el resultado en un JTextArea.
// Creo que se puede simplificar (quitar lo del DefaultStyledDocument
// y el GapContent) ya que la clave esta en utilizar ademas
// una fuente que soporte Unicode (en este caso
// Arial Unicode MS).

class DemoInputStreamReaderCodificacionGUI extends JFrame{
   
   DemoInputStreamReaderCodificacionGUI(String fich){
      super("Demo caracteres");
      
      Container cp = getContentPane();
      
      cp.setLayout(new FlowLayout());
      
      
      JPanel p = new JPanel();
         
      int c;
            
      String cadena = "";
      
      try{
         InputStreamReader fr = new InputStreamReader(new 
               FileInputStream(fich),"UTF-8");         
         while ((c=fr.read())!=-1){            
            cadena = cadena + String.valueOf((char)c);
         }
         fr.close();
      }catch(IOException e){
         System.out.println("Error E/S");
         e.printStackTrace();
      }
      

      JTextArea jta = new JTextArea(10,10);
      
      Font font = new java.awt.Font("Arial Unicode MS", java.awt.Font.PLAIN, 24);
      
      jta.setPreferredSize(new Dimension(400,400));
      
      jta.setFont(font);
      
      jta.append(cadena);
      
      p.setPreferredSize(new Dimension(600,600));
      
      p.setLayout(new FlowLayout());
      
      p.add(jta);

      cp.add(p);

      

      setVisible(true);
      setSize(700,700); 
      
      validate();
      repaint();
      
   }
   
   
   public static void main(String[] args){
      new DemoInputStreamReaderCodificacionGUI( args[0]);
      
   }
}