import java.io.*;

class LeePrimitivos extends FilterInputStream{
   public LeePrimitivos(InputStream in){
      super(in);
   }

   public int leeInt() throws IOException{
      int val = 0x00000000;
      
      val = val | ((read() & 0xFF) << 24);
      val = val | ((read() & 0xFF) << 16);
      val = val | ((read() & 0xFF) << 8);
      val = val | ((read() & 0xFF));
      
      return val;
   }
   
   public boolean leeBoolean() throws IOException{
      int val = read();
      if (val==1)
         return true;
      else
         return false;
   }
   
   public double leeDouble() throws IOException{
      long val = 0;
      
      for (int i=0; i<8;i++)
         val = val | ((read() & 0xFFL) << ((7-i)*8));
      
      return  Double.longBitsToDouble(val);
      
   }
   
}
